QCPAxisTickerDateTime Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Functions | Static Public Functions | Protected Types | Protected Functions
QCPAxisTickerDateTime Class Reference

Specialized axis ticker for calendar dates and times as axis ticks. More...

Inheritance diagram for QCPAxisTickerDateTime:

## Public Functions
| QCPAxisTickerDateTime ()
QString | dateTimeFormat () const
Qt::TimeSpec | dateTimeSpec () const
QTimeZone | timeZone () const
void | setDateTimeFormat (const QString &format)
void | setDateTimeSpec (Qt::TimeSpec spec)
void | setTimeZone (const QTimeZone &zone)
void | setTickOrigin (double origin)
void | setTickOrigin (const QDateTime &origin)
Public Functions inherited from QCPAxisTicker
| QCPAxisTicker ()
TickStepStrategy | tickStepStrategy () const
int | tickCount () const
double | tickOrigin () const
void | setTickStepStrategy (TickStepStrategy strategy)
void | setTickCount (int count)
void | setTickOrigin (double origin)
virtual void | generate (const QCPRange &range, const QLocale &locale, QChar formatChar, int precision, QVector< double > &ticks, QVector< double > *subTicks, QVector< QString > *tickLabels)

## Static Public Functions
static QDateTime | keyToDateTime (double key)
static double | dateTimeToKey (const QDateTime &dateTime)
static double | dateTimeToKey (const QDate &date, Qt::TimeSpec timeSpec=Qt::LocalTime)

## Protected Types
enum | DateStrategy

## Protected Functions
virtual double | getTickStep (const QCPRange &range)
virtual int | getSubTickCount (double tickStep)
virtual QString | getTickLabel (double tick, const QLocale &locale, QChar formatChar, int precision)
virtual QVector< double > | createTickVector (double tickStep, const QCPRange &range)
Protected Functions inherited from QCPAxisTicker
virtual double | getTickStep (const QCPRange &range)
virtual int | getSubTickCount (double tickStep)
virtual QString | getTickLabel (double tick, const QLocale &locale, QChar formatChar, int precision)
virtual QVector< double > | createTickVector (double tickStep, const QCPRange &range)
virtual QVector< double > | createSubTickVector (int subTickCount, const QVector< double > &ticks)
virtual QVector< QString > | createLabelVector (const QVector< double > &ticks, const QLocale &locale, QChar formatChar, int precision)
void | trimTicks (const QCPRange &range, QVector< double > &ticks, bool keepOneOutlier) const
double | pickClosest (double target, const QVector< double > &candidates) const
double | getMantissa (double input, double *magnitude=nullptr) const
double | cleanMantissa (double input) const

## Additional Inherited Members
Public Types inherited from QCPAxisTicker
enum | TickStepStrategy

## Detailed Description

Specialized axis ticker for calendar dates and times as axis ticks.

This QCPAxisTicker subclass generates ticks that correspond to real calendar dates and times. The plot axis coordinate is interpreted as Unix Time, so seconds since Epoch (January 1, 1970, 00:00 UTC). This is also used for example by QDateTime in the `toTime_t()/setTime_t()` methods with a precision of one second. Since Qt 4.7, millisecond accuracy can be obtained from QDateTime by using `QDateTime::fromMSecsSinceEpoch()/1000.0`. The static methods dateTimeToKey and keyToDateTime conveniently perform this conversion achieving a precision of one millisecond on all Qt versions.

The format of the date/time display in the tick labels is controlled with setDateTimeFormat. If a different time spec or time zone shall be used for the tick label appearance, see setDateTimeSpec or setTimeZone, respectively.

This ticker produces unequal tick spacing in order to provide intuitive date and time-of-day ticks. For example, if the axis range spans a few years such that there is one tick per year, ticks will be positioned on 1. January of every year. This is intuitive but, due to leap years, will result in slightly unequal tick intervals (visually unnoticeable). The same can be seen in the image above: even though the number of days varies month by month, this ticker generates ticks on the same day of each month.

If you would like to change the date/time that is used as a (mathematical) starting date for the ticks, use the setTickOrigin(const QDateTime &origin) method overload, which takes a QDateTime. If you pass 15. July, 9:45 to this method, the yearly ticks will end up on 15. July at 9:45 of every year.

The ticker can be created and assigned to an axis like this:

QSharedPointer<QCPAxisTickerDateTime> dateTimeTicker(new QCPAxisTickerDateTime);
customPlot->xAxis->setTicker(dateTimeTicker);
customPlot->xAxis->setRange(QCPAxisTickerDateTime::dateTimeToKey(QDate(2013, 11, 16)), QCPAxisTickerDateTime::dateTimeToKey(QDate(2015, 5, 2)));
dateTimeTicker->setDateTimeFormat("d. MMM\nyyyy");
QCPAxisTickerDateTime
Specialized axis ticker for calendar dates and times as axis ticks.
Definition: axistickerdatetime.h:32
QCPAxisTickerDateTime::dateTimeToKey
static double dateTimeToKey(const QDateTime &dateTime)
Definition: axistickerdatetime.cpp:349

Note
  If you rather wish to display relative times in terms of days, hours, minutes, seconds and milliseconds, and are not interested in the intricacies of real calendar dates with months and (leap) years, have a look at QCPAxisTickerTime instead.

## Constructor & Destructor Documentation

## ◆ QCPAxisTickerDateTime()

QCPAxisTickerDateTime::QCPAxisTickerDateTime | ( |  | ) |

Constructs the ticker and sets reasonable default values. Axis tickers are commonly created managed by a QSharedPointer, which then can be passed to QCPAxis::setTicker.

## Member Function Documentation

## ◆ setDateTimeFormat()

void QCPAxisTickerDateTime::setDateTimeFormat | ( | const QString & | format | ) |

Sets the format in which dates and times are displayed as tick labels. For details about the format string, see the documentation of QDateTime::toString().

Typical expressions are

`d` | The day as a number without a leading zero (1 to 31)
`dd` | The day as a number with a leading zero (01 to 31)
`ddd` | The abbreviated localized day name (e.g. 'Mon' to 'Sun'). Uses the system locale to localize the name, i.e. QLocale::system().
`dddd` | The long localized day name (e.g. 'Monday' to 'Sunday'). Uses the system locale to localize the name, i.e. QLocale::system().
`M` | The month as a number without a leading zero (1 to 12)
`MM` | The month as a number with a leading zero (01 to 12)
`MMM` | The abbreviated localized month name (e.g. 'Jan' to 'Dec'). Uses the system locale to localize the name, i.e. QLocale::system().
`MMMM` | The long localized month name (e.g. 'January' to 'December'). Uses the system locale to localize the name, i.e. QLocale::system().
`yy` | The year as a two digit number (00 to 99)
`yyyy` | The year as a four digit number. If the year is negative, a minus sign is prepended, making five characters.
`h` | The hour without a leading zero (0 to 23 or 1 to 12 if AM/PM display)
`hh` | The hour with a leading zero (00 to 23 or 01 to 12 if AM/PM display)
`H` | The hour without a leading zero (0 to 23, even with AM/PM display)
`HH` | The hour with a leading zero (00 to 23, even with AM/PM display)
`m` | The minute without a leading zero (0 to 59)
`mm` | The minute with a leading zero (00 to 59)
`s` | The whole second, without any leading zero (0 to 59)
`ss` | The whole second, with a leading zero where applicable (00 to 59)
`z` | The fractional part of the second, to go after a decimal point, without trailing zeroes (0 to 999). Thus "s.z" reports the seconds to full available (millisecond) precision without trailing zeroes.
`zzz` | The fractional part of the second, to millisecond precision, including trailing zeroes where applicable (000 to 999).
`AP` or `A` | Use AM/PM display. A/AP will be replaced by an upper-case version of either QLocale::amText() or QLocale::pmText().
`ap` or `a` | Use am/pm display. a/ap will be replaced by a lower-case version of either QLocale::amText() or QLocale::pmText().
`t` | The timezone (for example "CEST")

Newlines can be inserted with `"\n"`, literal strings (even when containing above expressions) by encapsulating them using single-quotes. A literal single quote can be generated by using two consecutive single quotes in the format.

See also
  setDateTimeSpec, setTimeZone

## ◆ setDateTimeSpec()

void QCPAxisTickerDateTime::setDateTimeSpec | ( | Qt::TimeSpec | spec | ) |

Sets the time spec that is used for creating the tick labels from corresponding dates/times.

The default value of QDateTime objects (and also QCPAxisTickerDateTime) is `Qt::LocalTime`. However, if the displayed tick labels shall be given in UTC, set spec to `Qt::UTC`.

Tick labels corresponding to other time zones can be achieved with setTimeZone (which sets spec to `Qt::TimeZone` internally). Note that if spec is afterwards set to not be `Qt::TimeZone` again, the setTimeZone setting will be ignored accordingly.

See also
  setDateTimeFormat, setTimeZone

## ◆ setTimeZone()

void QCPAxisTickerDateTime::setTimeZone | ( | const QTimeZone & | zone | ) |

Sets the time zone that is used for creating the tick labels from corresponding dates/times. The time spec (setDateTimeSpec) is set to `Qt::TimeZone`.

See also
  setDateTimeFormat, setTimeZone

## ◆ setTickOrigin() [1/2]

void QCPAxisTickerDateTime::setTickOrigin | ( | double | origin | ) |

Sets the tick origin (see QCPAxisTicker::setTickOrigin) in seconds since Epoch (1. Jan 1970, 00:00 UTC). For the date time ticker it might be more intuitive to use the overload which directly takes a QDateTime, see setTickOrigin(const QDateTime &origin).

This is useful to define the month/day/time recurring at greater tick interval steps. For example, If you pass 15. July, 9:45 to this method and the tick interval happens to be one tick per year, the ticks will end up on 15. July at 9:45 of every year.

## ◆ setTickOrigin() [2/2]

void QCPAxisTickerDateTime::setTickOrigin | ( | const QDateTime & | origin | ) |

Sets the tick origin (see QCPAxisTicker::setTickOrigin) as a QDateTime origin.

This is useful to define the month/day/time recurring at greater tick interval steps. For example, If you pass 15. July, 9:45 to this method and the tick interval happens to be one tick per year, the ticks will end up on 15. July at 9:45 of every year.

## ◆ keyToDateTime()

QDateTime QCPAxisTickerDateTime::keyToDateTime | ( | double | key | ) |
| static

A convenience method which turns key (in seconds since Epoch 1. Jan 1970, 00:00 UTC) into a QDateTime object. This can be used to turn axis coordinates to actual QDateTimes.

The accuracy achieved by this method is one millisecond, irrespective of the used Qt version (it works around the lack of a QDateTime::fromMSecsSinceEpoch in Qt 4.6)

See also
  dateTimeToKey

## ◆ dateTimeToKey() [1/2]

double QCPAxisTickerDateTime::dateTimeToKey | ( | const QDateTime & | dateTime | ) |
| static

This is an overloaded function.
A convenience method which turns a QDateTime object into a double value that corresponds to seconds since Epoch (1. Jan 1970, 00:00 UTC). This is the format used as axis coordinates by QCPAxisTickerDateTime.

The accuracy achieved by this method is one millisecond, irrespective of the used Qt version (it works around the lack of a QDateTime::toMSecsSinceEpoch in Qt 4.6)

See also
  keyToDateTime

## ◆ dateTimeToKey() [2/2]

double QCPAxisTickerDateTime::dateTimeToKey | ( | const QDate & | date,
|  | Qt::TimeSpec | timeSpec = `Qt::LocalTime`
| ) |  |
| static

This is an overloaded function.
A convenience method which turns a QDate object into a double value that corresponds to seconds since Epoch (1. Jan 1970, 00:00 UTC). This is the format used as axis coordinates by QCPAxisTickerDateTime.

The returned value will be the start of the passed day of date, interpreted in the given timeSpec.

See also
  keyToDateTime

## ◆ getTickStep()

double QCPAxisTickerDateTime::getTickStep | ( | const QCPRange & | range | ) |
| protectedvirtual

Returns a sensible tick step with intervals appropriate for a date-time-display, such as weekly, monthly, bi-monthly, etc.

Note that this tick step isn't used exactly when generating the tick vector in createTickVector, but only as a guiding value requiring some correction for each individual tick interval. Otherwise this would lead to unintuitive date displays, e.g. jumping between first day in the month to the last day in the previous month from tick to tick, due to the non-uniform length of months. The same problem arises with leap years.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

## ◆ getSubTickCount()

int QCPAxisTickerDateTime::getSubTickCount | ( | double | tickStep | ) |
| protectedvirtual

Returns a sensible sub tick count with intervals appropriate for a date-time-display, such as weekly, monthly, bi-monthly, etc.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

## ◆ getTickLabel()

QString QCPAxisTickerDateTime::getTickLabel | ( | double | tick,
|  | const QLocale & | locale,
|  | QChar | formatChar,
|  | int | precision
| ) |  |
| protectedvirtual

Generates a date/time tick label for tick coordinate tick, based on the currently set format (setDateTimeFormat), time spec (setDateTimeSpec), and possibly time zone (setTimeZone).

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

## ◆ createTickVector()

QVector< double > QCPAxisTickerDateTime::createTickVector | ( | double | tickStep,
|  | const QCPRange & | range
| ) |  |
| protectedvirtual

Uses the passed tickStep as a guiding value and applies corrections in order to obtain non-uniform tick intervals but intuitive tick labels, e.g. falling on the same day of each month.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

The documentation for this class was generated from the following files:

- src/axis/axistickerdatetime.h
- src/axis/axistickerdatetime.cpp